#ifndef ACCOUNTLIST_H
#define ACCOUNTLIST_H
#include <time.h>
#include <qmainwindow.h>
#include <qlcdnumber.h>
#include <qtimer.h>
#include "accountlistui.h"
#include "pstore.h"

class QPEToolBar;
class QPEMenuBar;
class QPushButton;
class QListView;
class QLineEdit;
class QLCDNumber;
class QActionGroup;
class QAction;
class Config;
class AccountView;

class AccountList : public QMainWindow
{ 
	Q_OBJECT
public:
    AccountList(PasswordStore *ps,QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~AccountList();

public slots:
    void lock();
    void newAccount();
    void passwordEntered(const QString &);
    void selectAccount(QListViewItem *,const QPoint & pnt, int c);
    void selectAccount(QListViewItem *);
	void selectionChanged(QListViewItem *);
	void resetTimer();
	void updateCountDown();
	void settings();
	void changePassword();
	void importAccounts();
	void exportAccounts();
	void editCategory();
	void changeView();
protected:	
	void showAccountList();
	void applySettings();

    QActionGroup *mAccountActions;
   
	QAction *mCategoryEdit;
	
    QPushButton *wNew,*wLock,*wReset;
    QPEToolBar *mToolBar;
    QPEMenuBar *mMenuBar;
   
    QListView *wAccounts;
    QLineEdit *wPassword;
    QLCDNumber *wLCD;
	AccountView *mAccountView;

	
	Config *mConfig;
	int mTimerStart;
	bool mTimerEnabled;
	bool mTimerPowerOff;
	bool mHideAccounts;
	bool mAccountList;
	bool mAccountViewLock;
	bool mTimerViewingAC;
	int mSeconds;

	timer_t mStartTime;
	
	QTimer *mUpdateTimer;
	PasswordStore *mPStore;

};

#endif // ACCOUNTLIST_H
