#ifndef ACCOUNTVIEW_H
#define ACCOUNTVIEW_H
#include <time.h>
#include "pstore.h"
#include "accountviewui.h"


class Config;
class QTimer;

class AccountView : public AccountViewUI
{ 
    Q_OBJECT

public:
    AccountView(PasswordStore &store, Config *config, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~AccountView();

	void loadAccount(QString name);
	void updateCategories();
	void storeAccount();
public slots:
    void deleteAccount();
    void saveAccount();
	void generatePassword();
	void selectCategory(const QString &category);
	void accept();
	void timeout();
	void textChanged ( const QString & );
	void textChanged ();
protected:
	PasswordStore &mStore;
	PasswordData *mData;
	Config *mConfig;
	QTimer *mTimer;
	bool mEnableTimer;
	time_t mStartTime;
	time_t mTotalTime;
};

#endif // ACCOUNTVIEW_H
