#include <qstring.h>
#include <qstringlist.h>
#include <qpixmap.h>

#include <stdio.h>
#include "categories.h"

#include "icons/car.xpm"
#include "icons/computer.xpm"
#include "icons/creditcard.xpm"
#include "icons/dollar.xpm"
#include "icons/door.xpm"
#include "icons/dotdotdot.xpm"
#include "icons/etc.xpm"
#include "icons/web.xpm"
#include "icons/globe.xpm"
#include "icons/linux.xpm"
#include "icons/daemon.xpm"
#include "icons/house.xpm"
#include "icons/mail.xpm"
#include "icons/phone.xpm"
#include "icons/server.xpm"

#define DEFCAT(m) { #m, NULL, (const char ** ) m ##  _xpm },

#define NUMCATS (sizeof(categories)/sizeof(Category))

Category categories[]={
	DEFCAT(car)
	DEFCAT(computer)
	DEFCAT(creditcard)
	DEFCAT(dollar)
	DEFCAT(door)
	DEFCAT(dotdotdot)
	DEFCAT(etc)
	DEFCAT(globe)
	DEFCAT(linux)
	DEFCAT(daemon)
	DEFCAT(web)
	DEFCAT(house)
	DEFCAT(mail)
	DEFCAT(phone)
	DEFCAT(server)
	{ NULL,NULL,NULL },
};

int numberOfCategoryPixmaps(){
	return NUMCATS-1;
}

QPixmap *getCategoryPixmapByIndex(int i){
		if(!categories[i].mPixmap){
			categories[i].mPixmap=new QPixmap(categories[i].mXPM);
		}
		return categories[i].mPixmap;
}

QString getCategoryPixmapName(int i){
	return QString(categories[i].mName);
}

int getCategoryPixmapIndex(QString name){
	for(unsigned int i=0;i<(NUMCATS-1);i++){
		if(categories[i].mName==name){
				return i;
		}
	}
	return -1;
}

QPixmap *getCategoryPixmapByName(QString name){
	for(unsigned int i=0;i<(NUMCATS-1);i++){
		if(categories[i].mName==name){
				if(!categories[i].mPixmap){
					categories[i].mPixmap=new QPixmap(categories[i].mXPM);
				}
				return categories[i].mPixmap;
		}
	}
	return NULL;
}

QStringList getCategoryPixmapNames(){
	QStringList list;
	for(int i=0;categories[i].mName!=NULL;i++){
		QString s = categories[i].mName;
		list.append(s);
	}
	return list;
}
	
