#include <qpushbutton.h>
#include <qlineedit.h>
#include "changepassword.h"

/* 
 *  Constructs a ChangePassword which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
ChangePassword::ChangePassword( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : ChangePasswordUI( parent, name, modal, fl )
{
	wChangePassword->setEnabled(false);
}

/*  
 *  Destroys the object and frees any allocated resources
 */
ChangePassword::~ChangePassword()
{
    // no need to delete child widgets, Qt does it all for us
}

/* 
 * public slot
 */
void ChangePassword::hidePasswords(bool t)
{
	if(t){
		wPassword1->setEchoMode(QLineEdit::Password);
		wPassword2->setEchoMode(QLineEdit::Password);
	} else {
		wPassword1->setEchoMode(QLineEdit::Normal);
		wPassword2->setEchoMode(QLineEdit::Normal);
	}

}

void ChangePassword::checkPasswords(){
	if(wPassword1->text() == wPassword2->text())
		if(wPassword1->text().length()>2){
			wChangePassword->setEnabled(true);
			return;
		}
	wChangePassword->setEnabled(false);
}
