#ifndef ERROR_H
#define ERROR_H

#include <stdio.h>
#include <gdbm.h>

#define Error(msg) _Error(__FILE__,__LINE__,msg)
#define Errno(msg) _Errno(__FILE__,__LINE__,msg)
#define GDBMErrno(msg) _GDBMErrno(__FILE__,__LINE__,msg)

#define CHKPTR(ptr) if(!ptr) _Error(__FILE__,__LINE__,##ptr"==NULL");

void _Error(char *file, int line, char *msg);

inline void _Errno(char *file, int line, int err){ 
	_Error(file, line, strerror(err));
}

inline void _GDBMErrno(char *file, int line, int err){
	_Error(file, line, gdbm_strerror(err));
}

#endif
