#ifndef KEYRING_H
#define KEYRING_H

#include <unistd.h>

#include <qlineedit.h>
#include <qpe/qpeapplication.h>
#include <qpe/global.h>

#include <qmessagebox.h>

#include "pstore.h"
#include "setpassword.h"
#include "accountlist.h"
#include "accountviewui.h"


class Keyring: public QPEApplication {
	Q_OBJECT
public:
		Keyring(int argc,char **argv):QPEApplication(argc,argv){}

		void start(){
			
			mPWDFile = Global::applicationFileName("keyring",
						                           PWD_DB);
	
			qDebug(mPWDFile);
			
			if(access(mPWDFile.latin1(),R_OK|R_OK)==0){
				mPStore = PasswordStore::open(mPWDFile);
				if(!mPStore)
						Error("Unable to open existing database");
				mCurrentView = new AccountList(mPStore);
				showMainWidget(mCurrentView);
			} else {
				SetPassword *sp = new SetPassword();
				mCurrentView=sp;
				connect(sp,SIGNAL(nextClicked()),this,SLOT(setPassword()));
				showMainWidget(mCurrentView);
			}
		}
public slots:
		void setPassword(){
				SetPassword *sp = (SetPassword *) mCurrentView;
				QString pwd = sp->wPassword1->text();
				mPStore = PasswordStore::create(mPWDFile,pwd);

				
				mCurrentView = new AccountList(mPStore);
				showMainWidget(mCurrentView);
				
				sp->hide();
				delete sp;
		}
		

protected:
	QWidget *mCurrentView;
	PasswordStore *mPStore;
	QString mPWDFile;
};

#endif
