#include <qpushbutton.h>
#include <qlineedit.h>
#include "setpassword.h"

/* 
 *  Constructs a SetPassword which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 */
SetPassword::SetPassword( QWidget* parent,  const char* name, WFlags)
    : SetPasswordUI( parent, name, TRUE )
{
	wNext->setEnabled(false);	
}

void SetPassword::hidePasswords(bool t){
	if(t==false){
		wPassword1->setEchoMode(QLineEdit::Normal);
		wPassword2->setEchoMode(QLineEdit::Normal);
	} else {
		wPassword1->setEchoMode(QLineEdit::Password);
		wPassword2->setEchoMode(QLineEdit::Password);
	}
}


/*  
 *  Destroys the object and frees any allocated resources
 */
SetPassword::~SetPassword()
{
    // no need to delete child widgets, Qt does it all for us
}

/* 
 * public slot
 */
void SetPassword::checkPasswords()
{
	qDebug("Checking passwords");
	if((wPassword1->text() == wPassword2->text()) && wPassword1->text().length()>2) 
		wNext->setEnabled(true);
	else wNext->setEnabled(false);
}
/* 
 * public slot
 */
void SetPassword::next()
{
    accept();
}

