#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

#include <qpe/qpeapplication.h>
#include <qlineedit.h>

#include <qmessagebox.h>

#include "pstore.h"

#include "accountlist.h"
#include "setpassword.h"


int start(QPEApplication &a,QString pwdFile){
    if(access(pwdFile.latin1(),R_OK|W_OK)!=0){
        SetPassword sp;

		qDebug("Creating database");
		
        a.showMainWidget(&sp);
        if(sp.exec()==QDialog::Accepted){
            if(sp.wPassword1->text() != sp.wPassword2->text()){
                QMessageBox::warning(&sp,sp.tr("Incomplete Setup"),sp.tr("Keyring was not initialized\nbecause the passwords you\nentered do not match"),
                        QMessageBox::Ok,QMessageBox::NoButton);
                exit(1);
            }    

            if(sp.wPassword1->text().length()<=2){
                QMessageBox::warning(&sp,sp.tr("Incomplete Setup"),sp.tr("Keyring was not initialized\nbecause the passwords you\nentered are too short"),
                        QMessageBox::Ok,QMessageBox::NoButton);
                exit(1);
            }
            
            QString pwd = sp.wPassword1->text();
            PasswordStore *pStore = PasswordStore::create(pwdFile,pwd);

			//FIXME: By deleting pStore we force the password database to close
			//and remain consistant.
            delete pStore;
            return 0;
        } else exit(2);
    } 
	return 0;
}
